CREATE OR ALTER PROCEDURE MIGRACAO_FACIL_MIGRADOR
AS
DECLARE VARIABLE CODIGO INTEGER;
DECLARE VARIABLE TIPOPESSOA VARCHAR(1);
DECLARE VARIABLE NOME VARCHAR(255);
DECLARE VARIABLE APELIDO VARCHAR(255);
DECLARE VARIABLE ENDERECO VARCHAR(255);
DECLARE VARIABLE COMPLEMENT VARCHAR(255);
DECLARE VARIABLE NUM_END VARCHAR(255);
DECLARE VARIABLE BAIRRO VARCHAR(255);
DECLARE VARIABLE CIDADE VARCHAR(255);
DECLARE VARIABLE CEP VARCHAR(255);
DECLARE VARIABLE TELEFONE VARCHAR(255);
DECLARE VARIABLE CELULAR VARCHAR(255);
DECLARE VARIABLE INSCRICAO VARCHAR(255);
DECLARE VARIABLE CNPJ VARCHAR(255);
DECLARE VARIABLE CPF VARCHAR(255);
DECLARE VARIABLE IDENTIDADE VARCHAR(255);
DECLARE VARIABLE DATA_NASC VARCHAR(255);
DECLARE VARIABLE PAI VARCHAR(255);
DECLARE VARIABLE MAE VARCHAR(255);
DECLARE VARIABLE CADASTRO VARCHAR(255);
DECLARE VARIABLE LIMITE_CR1 DOUBLE PRECISION;
DECLARE VARIABLE BLOQUEADO VARCHAR(1);
DECLARE VARIABLE OBS VARCHAR(255);
DECLARE VARIABLE EMAIL VARCHAR(255);
DECLARE VARIABLE EMAIL2 VARCHAR(255);
DECLARE VARIABLE CONTATO VARCHAR(255);

DECLARE VARIABLE RAZAOSOC VARCHAR(255);
DECLARE VARIABLE FAX VARCHAR(255);
DECLARE VARIABLE TIPO_IE DOUBLE PRECISION;

DECLARE VARIABLE DESCRICAO VARCHAR(255);

DECLARE VARIABLE ID_MARCA INTEGER;

DECLARE VARIABLE ID_UNIDADE INTEGER;
DECLARE VARIABLE SIMBOLO VARCHAR(255);
DECLARE VARIABLE FRACIONAR VARCHAR(1);

DECLARE VARIABLE ID INTEGER;
DECLARE VARIABLE TIPO INTEGER;
DECLARE VARIABLE PRODUTO VARCHAR(255);
DECLARE VARIABLE UNIDADE VARCHAR(255);
DECLARE VARIABLE ESTOQUE DOUBLE PRECISION;
DECLARE VARIABLE MINIMO DOUBLE PRECISION;
DECLARE VARIABLE GRUPO INTEGER;
DECLARE VARIABLE PCO_COMPRA DOUBLE PRECISION;
DECLARE VARIABLE PCO_CUSTO DOUBLE PRECISION;
DECLARE VARIABLE MARGEM_LC DOUBLE PRECISION;
DECLARE VARIABLE PCO_VENDA DOUBLE PRECISION;
DECLARE VARIABLE COMISSAO DOUBLE PRECISION;
DECLARE VARIABLE CODBARRA VARCHAR(255);
DECLARE VARIABLE ORIGEM INTEGER;
DECLARE VARIABLE CST INTEGER;
DECLARE VARIABLE ICMS DOUBLE PRECISION;
DECLARE VARIABLE NUM_FABRIC VARCHAR(255);
DECLARE VARIABLE LOCALIZA VARCHAR(255);
DECLARE VARIABLE APLICACAO VARCHAR(255);
DECLARE VARIABLE COD_NCM INTEGER;
DECLARE VARIABLE CEST INTEGER;
DECLARE VARIABLE CST_PIS INTEGER;
DECLARE VARIABLE ALIQPIS DOUBLE PRECISION;
DECLARE VARIABLE CSTCOFINS INTEGER;
DECLARE VARIABLE ALIQCOFINS DOUBLE PRECISION;
DECLARE VARIABLE CST_IPI INTEGER;
DECLARE VARIABLE IPI DOUBLE PRECISION;
DECLARE VARIABLE ALIQPISENT DOUBLE PRECISION;
DECLARE VARIABLE ALICOFINSE INTEGER;
DECLARE VARIABLE COD_MARCA INTEGER;
DECLARE VARIABLE PESO DOUBLE PRECISION;
DECLARE VARIABLE APLICACAO2 VARCHAR(255);
DECLARE VARIABLE FAT_CONVER DOUBLE PRECISION;
DECLARE VARIABLE FCP_ALIQ DOUBLE PRECISION;
DECLARE VARIABLE COD_LOCALIZA INTEGER;
DECLARE VARIABLE INATIVO VARCHAR(1);
BEGIN

   /*******************************************************************************

    PROCEDIMENTO PARA MIGRAR O BANCO DE DADOS DAO SISTEMA FACIL. PARA O
    O BANCO DO MIGRADOR
    SIGA AS INSTRUCOES.
    
    1) CONECTAR NO BANCO DA FACIL COM OU SEM ALIAS
    2) INSTALAR A PROCEDURE MIGRACAO_FACIL_MIGRADOR
    3) CONFIGURAR UM BANCO MIGRADOR LIMPO COM O ALIAS MIGRADOR
    4) EXECUTE A PROCEDURE MIGRACAO_FACIL_MIGRADOR
    5) PROCEDA COM A MIGRACAO NO MIGRADOR COMO SE TIVESSE IMPORTADO AS PLANILHAS
    COM SUCESSO!
    
    ESTE SCRIPT FUNCIONA PARA AS VERSOES:
    
    5.2.1.0

*******************************************************************************/

   EXECUTE STATEMENT('EXECUTE PROCEDURE UTIL_RESET;') ON EXTERNAL 'localhost:MIGRADOR' AS USER 'sysdba' PASSWORD 'masterkey';

   --M I G R A C A O   D E   C L I E N T E S

   FOR
      SELECT
         CLIENTES_ID AS CODIGO,
         IIF(A.CLIENTE_F_J = 0, 'F', 'J') AS TIPOPESSOA,
         SUBSTRING(COALESCE(A.CLIENTE_NOME, 'SEM NOME') FROM 1 FOR 50) AS NOME,
         SUBSTRING(COALESCE(A.CLIENTE_NOME, 'SEM NOME1') FROM 1 FOR 50) AS APELIDO,
         SUBSTRING(COALESCE(A.CLIENTE_ENDERECO, 'SEM ENDERECO') FROM 1 FOR 50) AS ENDERECO,
         A.CLIENTE_COMPLEMENTO AS COMPLEMENT,
         COALESCE(SUBSTRING(A.CLIENTE_NUMERO FROM 1 FOR 5), 'SN') AS NUM_END,
         SUBSTRING(COALESCE(A.CLIENTE_BAIRRO, 'SEM BAIRRO') FROM 1 FOR 50) AS BAIRRO,
         B.LOCALIDADE_NOME AS CIDADE,
         A.LOCALIDADE_CEP AS CEP,
         COALESCE(CLIENTE_DDD_TELEFONE1, '33') || CLIENTE_TELEFONE1 AS TELEFONE,
         COALESCE(CLIENTE_DDD_TELEFONE2, '33') || CLIENTE_TELEFONE2 AS CELULAR,
         A.CLIENTE_RG_IE AS INSCRICAO,
         A.CLIENTE_CPF_CNPJ AS CNPJ,
         NULL AS CPF,
         NULL AS IDENTIDADE,
         CLIENTE_NASCIMENTO_FUNDACAO AS DATA_NASC,
         A.CLIENTE_PAI AS PAI,
         A.CLIENTE_MAE AS MAE,
         A.CLIENTE_CADASTRO AS CADASTRO,
         A.CLIENTE_LIMITE_CREDITO AS LIMITE_CR1,
         IIF(A.CLIENTE_BLOQUEADO_SISTEMA = 0, 'N', 'S') AS BLOQUEADO,
         A.CLIENTE_OBS AS OBS,
         A.CLIENTE_EMAIL AS EMAIL,
         NULL AS EMAIL2,
         A.CLIENTE_CONTATO AS CONTATO
      FROM
         CLIENTES A
      JOIN
         LOCALIDADES B ON (A.LOCALIDADE_CEP = B.LOCALIDADE_CEP)
      INTO
         :CODIGO, :TIPOPESSOA, :NOME, :APELIDO, :ENDERECO, :COMPLEMENT,
         :NUM_END, :BAIRRO, :CIDADE, :CEP, :TELEFONE, :CELULAR, :INSCRICAO,
         :CNPJ, :CPF, :IDENTIDADE, :DATA_NASC, :PAI, :MAE, :CADASTRO,
         :LIMITE_CR1, :BLOQUEADO, :OBS, :EMAIL, :EMAIL2, :CONTATO
   DO
   BEGIN
      EXECUTE STATEMENT('INSERT INTO CLIENTES (CODIGO,TIPOPESSOA,NOME,APELIDO,ENDERECO,COMPLEMENT,NUM_END,BAIRRO,CIDADE,CEP,TELEFONE,CELULAR,INSCRICAO,CNPJ,CPF,IDENTIDADE,DATA_NASC,PAI,MAE,CADASTRO,LIMITE_CR1,BLOQUEADO,OBS,EMAIL,EMAIL2,CONTATO)  VALUES (?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?);')(:CODIGO,
         :TIPOPESSOA, :NOME, :APELIDO, :ENDERECO, :COMPLEMENT, :NUM_END,
         :BAIRRO, :CIDADE, :CEP, :TELEFONE, :CELULAR, :INSCRICAO, :CNPJ, :CPF,
         :IDENTIDADE, :DATA_NASC, :PAI, :MAE, :CADASTRO, :LIMITE_CR1,
         :BLOQUEADO, :OBS, :EMAIL, :EMAIL2, :CONTATO) ON EXTERNAL 'localhost:MIGRADOR' AS USER 'sysdba' PASSWORD 'masterkey';
   END

   --M I G R A C A O   D E   F O R N E C E D O R E S
   FOR
      SELECT
         A.FORNECEDORES_ID AS CODIGO,
         IIF(A.FORNECEDOR_F_J = 0, 'F', 'J') AS TIPOPESSOA,
         SUBSTRING(COALESCE(A.FORNECEDOR_NOME, 'SEM NOME') FROM 1 FOR 50) AS RAZAOSOC,
         SUBSTRING(COALESCE(A.FORNECEDOR_NOME1, 'SEM NOME') FROM 1 FOR 50) AS NOME,
         SUBSTRING(COALESCE(A.FORNECEDOR_ENDERECO, 'SEM ENDERECO') FROM 1 FOR 50) AS ENDERECO,
         A.FORNECEDOR_COMPLEMENTO AS COMPLEMENT,
         COALESCE(SUBSTRING(A.FORNECEDOR_NUMERO FROM 1 FOR 5), 'SN') AS NUM_END,
         SUBSTRING(COALESCE(A.FORNECEDOR_BAIRRO, 'SEM BAIRRO') FROM 1 FOR 50) AS BAIRRO,
         B.LOCALIDADE_NOME AS CIDADE,
         COALESCE(SUBSTRING(A.LOCALIDADE_CEP FROM 1 FOR 8), '39740000') AS CEP,
         COALESCE(FORNECEDOR_DDD_TELEFONE1, '33') || FORNECEDOR_TELEFONE1 AS TELEFONE,
         COALESCE(FORNECEDOR_DDD_TELEFONE2, '33') || FORNECEDOR_TELEFONE2 AS FAX,
         SUBSTRING(A.FORNECEDOR_CPF_CNPJ FROM 1 FOR 18) AS CNPJ,
         1.AS TIPO_IE,
         A.FORNECEDOR_RG_IE AS INSCRICAO,
         NULL AS CPF,
         NULL AS IDENTIDADE,
         A.FORNECEDOR_OBSERVACAO AS OBS,
         A.FORNECEDOR_EMAIL AS EMAIL,
         A.FORNECEDOR_CONTATO AS CONTATO
      FROM
         FORNECEDORES A
      JOIN
         LOCALIDADES B ON (A.LOCALIDADE_CEP = B.LOCALIDADE_CEP)
      INTO
         :CODIGO, :TIPOPESSOA, :RAZAOSOC, :NOME, :ENDERECO, :COMPLEMENT,
         :NUM_END, :BAIRRO, :CIDADE, :CEP, :TELEFONE, :FAX, :CNPJ, :TIPO_IE,
         :INSCRICAO, :CPF, :IDENTIDADE, :OBS, :EMAIL, :CONTATO
   DO
   BEGIN
      EXECUTE STATEMENT('INSERT INTO FORNECED (CODIGO,TIPOPESSOA,RAZAOSOC,NOME,ENDERECO,COMPLEMENT,NUM_END,BAIRRO,CIDADE,CEP,TELEFONE,FAX,CNPJ,TIPO_IE,INSCRICAO,CPF,IDENTIDADE,OBS,EMAIL,CONTATO)  VALUES (?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?);')(:CODIGO,
         :TIPOPESSOA, :RAZAOSOC, :NOME, :ENDERECO, :COMPLEMENT, :NUM_END,
         :BAIRRO, :CIDADE, :CEP, :TELEFONE, :FAX, :CNPJ, :TIPO_IE, :INSCRICAO,
         :CPF, :IDENTIDADE, :OBS, :EMAIL, :CONTATO) ON EXTERNAL 'localhost:MIGRADOR' AS USER 'sysdba' PASSWORD 'masterkey';
   END

   --M I G R A C A O   D E   G R U P O S
   FOR
      SELECT
         A.SUBGRUPOS_ID AS CODIGO,
         A.SUBGRUPO_NOME AS DESCRICAO,
         0.00 AS COMISSAO
      FROM
         SUBGRUPOS A
      INTO
         :CODIGO, :DESCRICAO, :COMISSAO
   DO
   BEGIN
      EXECUTE STATEMENT('INSERT INTO GRUPOS (CODIGO,DESCRICAO,COMISSAO)  VALUES (?,?,?);')(:CODIGO,
         :DESCRICAO, :COMISSAO) ON EXTERNAL 'localhost:MIGRADOR' AS USER 'sysdba' PASSWORD 'masterkey';
   END

   --M I G R A C A O   D E   M A R C A S
   FOR
      SELECT
         A.MARCAS_ID AS ID_MARCA,
         A.MARCA_NOME AS DESCRICAO
      FROM
         MARCAS A
      INTO
         :ID_MARCA, :DESCRICAO
   DO
   BEGIN
      EXECUTE STATEMENT('INSERT INTO MARCAS (ID_MARCA,DESCRICAO)  VALUES (?,?);')(:ID_MARCA,
         :DESCRICAO) ON EXTERNAL 'localhost:MIGRADOR' AS USER 'sysdba' PASSWORD 'masterkey';
   END

   --M I G R A C A O   D E   U N I D A D E S
   FOR
      SELECT
         A.UNIDADES_ID AS ID_UNIDADE,
         A.UNIDADE_NOME AS SIMBOLO,
         A.UNIDADE_NOME AS DESCRICAO,
         IIF(A.UNIDADE_FRACIONARIA = 0, 'N', 'S') AS FRACIONAR
      FROM
         UNIDADES A
      INTO
         :ID_UNIDADE, :SIMBOLO, :DESCRICAO, :FRACIONAR
   DO
   BEGIN
      EXECUTE STATEMENT('INSERT INTO UNIDADES (ID_UNIDADE,SIMBOLO,DESCRICAO,FRACIONAR)  VALUES (?,?,?,?);')(:ID_UNIDADE,
         :SIMBOLO, :DESCRICAO, :FRACIONAR) ON EXTERNAL 'localhost:MIGRADOR' AS USER 'sysdba' PASSWORD 'masterkey';
   END

   --M I G R A C A O   D E   P R O D U T O S
   FOR
      SELECT
         A.PRODUTOS_ID AS ID,
         CASE
            WHEN A.PRODUTO_TIPO = 5 THEN '00'
            WHEN A.PRODUTO_TIPO = 6 THEN '01'
            WHEN A.PRODUTO_TIPO = 11 THEN '06'
            WHEN A.PRODUTO_TIPO = 12 THEN '07'
            WHEN A.PRODUTO_TIPO = 13 THEN '08'
            WHEN A.PRODUTO_TIPO = 16 THEN '99'
            ELSE '00'
         END AS TIPO,
         A.PRODUTOS_ID AS CODIGO,
         UPPER(COALESCE(SUBSTRING(A.PRODUTO_NOME FROM 1 FOR 100), A.PRODUTO_NOME1)) AS PRODUTO,
         B.UNIDADE_NOME AS UNIDADE,
         A.PRODUTO_ESTOQUE AS ESTOQUE,
         A.PRODUTO_ESTOQUE_MINIMO AS MINIMO,
         A.SUBGRUPOS_ID AS GRUPO,
         IIF(A.PRODUTO_PRECO_CUSTO > 2147483647, 0, A.PRODUTO_PRECO_CUSTO) AS PCO_COMPRA,
         IIF(A.PRODUTO_PRECO_CUSTO > 2147483647, 0, A.PRODUTO_PRECO_CUSTO) AS PCO_CUSTO,
         IIF(A.PRODUTO_MARGEM_LUCRO > 8096, 0, A.PRODUTO_MARGEM_LUCRO) AS MARGEM_LC,
         IIF(A.PRODUTO_PRECO > 2147483647, 0, A.PRODUTO_PRECO) AS PCO_VENDA,
         A.PRODUTO_COMISSAO AS COMISSAO,
         A.PRODUTO_CODIGO_BARRAS AS CODBARRA,
         SUBSTRING(A.CST_ID FROM 1 FOR 1) AS ORIGEM,
         SUBSTRING(A.CST_ID FROM 2 FOR 2) AS CST,
         C.ALIQUOTA_VALOR AS ICMS,
         A.PRODUTO_COD_FAB AS NUM_FABRIC,
         A.PRODUTO_LOCALIZACAO AS LOCALIZA,
         A.PRODUTO_APLICACAO AS APLICACAO,
         COALESCE(A.NCM_NCM, '99999999') AS COD_NCM,
         A.PRODUTO_CEST AS CEST,
         COALESCE(A.CST_PIS_ID, '99') AS CST_PIS,
         COALESCE(A.PRODUTO_PIS, 0) AS ALIQPIS,
         COALESCE(A.CST_COFINS_ID, '99') AS CSTCOFINS,
         COALESCE(A.PRODUTO_COFINS, 0) AS ALIQCOFINS,
         COALESCE(A.CST_IPI_ID, '99') AS CST_IPI,
         COALESCE(A.PRODUTO_IPI, 0) AS IPI,
         COALESCE(A.PRODUTO_PIS_ENTRADA, 0.00) AS ALIQPISENT,
         COALESCE(A.PRODUTO_COFINS_ENTRADA, 0.00) AS ALICOFINSE,
         A.MARCAS_ID AS COD_MARCA,
         COALESCE(A.PRODUTO_PESO_BRUTO, 00.0) AS PESO,
         NULL AS APLICACAO2,
         1.00 AS FAT_CONVER,
         NULL AS FCP_ALIQ,
         NULL AS COD_LOCALIZA,
         IIF(A.PRODUTO_STATUS = 2, 'N', 'S') AS INATIVO
      FROM
         PRODUTOS A
      JOIN
         UNIDADES B ON (A.UNIDADES_ID = B.UNIDADES_ID)
      JOIN
         ALIQUOTAS C ON (A.ALIQUOTAS_ID = C.ALIQUOTAS_ID)
      INTO
         :ID, :TIPO, :CODIGO, :PRODUTO, :UNIDADE, :ESTOQUE, :MINIMO, :GRUPO,
         :PCO_COMPRA, :PCO_CUSTO, :MARGEM_LC, :PCO_VENDA, :COMISSAO, :CODBARRA,
         :ORIGEM, :CST, :ICMS, :NUM_FABRIC, :LOCALIZA, :APLICACAO, :COD_NCM,
         :CEST, :CST_PIS, :ALIQPIS, :CSTCOFINS, :ALIQCOFINS, :CST_IPI, :IPI,
         :ALIQPISENT, :ALICOFINSE, :COD_MARCA, :PESO, :APLICACAO2, :FAT_CONVER,
         :FCP_ALIQ, :COD_LOCALIZA, :INATIVO
   DO
   BEGIN
      EXECUTE STATEMENT('INSERT INTO ESTOQUE (ID,TIPO,CODIGO,PRODUTO,UNIDADE,ESTOQUE,MINIMO,GRUPO,PCO_COMPRA,PCO_CUSTO,MARGEM_LC,PCO_VENDA,COMISSAO,CODBARRA,ORIGEM,CST,ICMS,NUM_FABRIC,LOCALIZA,APLICACAO,COD_NCM,CEST,CST_PIS,ALIQPIS,CSTCOFINS,ALIQCOFINS,CST_IPI,IPI,ALIQPISENT,ALICOFINSE,COD_MARCA,PESO,APLICACAO2,FAT_CONVER,FCP_ALIQ,COD_LOCALIZA,INATIVO)  VALUES (?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?);')(:ID,
         :TIPO, :CODIGO, :PRODUTO, :UNIDADE, :ESTOQUE, :MINIMO, :GRUPO,
         :PCO_COMPRA, :PCO_CUSTO, :MARGEM_LC, :PCO_VENDA, :COMISSAO, :CODBARRA,
         :ORIGEM, :CST, :ICMS, :NUM_FABRIC, :LOCALIZA, :APLICACAO, :COD_NCM,
         :CEST, :CST_PIS, :ALIQPIS, :CSTCOFINS, :ALIQCOFINS, :CST_IPI, :IPI,
         :ALIQPISENT, :ALICOFINSE, :COD_MARCA, :PESO, :APLICACAO2, :FAT_CONVER,
         :FCP_ALIQ, :COD_LOCALIZA, :INATIVO) ON EXTERNAL 'localhost:MIGRADOR' AS USER 'sysdba' PASSWORD 'masterkey';
   END

END
